#!/bin/bash

#global state
lid_close=false
on_battery=false
lower_than_10=false
screen_open=false
fifo_data="fifo data"

#init setup
echo "state machine start"

get_lid_state() {
    local upower_dump=$1
    local lid_close_string=$(echo $upower_dump | grep -o "lid-is-closed: ..." | awk -F' ' '{print $2}')
    #init lid state
    if [[ "$lid_close_string" == "no" ]]; then
        lid_close=false
    else
        lid_close=true
    fi
}

get_charge_state() {
    local upower_dump=$1
    local on_battery_string=$(echo $upower_dump | grep -o "on-battery: ..." | awk -F' ' '{print $2}')
    #init on battery
    if [[ "$on_battery_string" == "no" ]]; then
        on_battery=false
    else
        on_battery=true
    fi
}

get_lower_state() {
    local upower_dump=$1
    local percentage=$(echo $upower_dump | grep -o "percentage: ..." | head -n 1 | awk -F' ' '{print $2}' | awk -F% '{print $1}')
    #init lower than 10%
    if [[ "$percentage" -gt "10" ]]; then
        lower_than_10=false
    else
        lower_than_10=true
    fi
}
#init screen state
get_screen_state() {
    #to do
    local dpms=$(cat /sys/class/drm/card1-DSI-1/dpms)

    if [[ "$dpms" == "On" ]]; then
        screen_open=true
    else
        screen_open=false
    fi

    local screen_on=$(echo $fifo_data | grep PowerSaveMode | grep 0)
    local screen_off=$(echo $fifo_data | grep PowerSaveMode | grep 3)
    if [[ "$screen_on" ]]; then
        screen_open=true
    fi

    if [[ "$screen_off" ]]; then
        screen_open=false
    fi


}

update_state() {
    upower_string=$(/usr/bin/upower --dump)
    get_lid_state "$upower_string"
    get_charge_state "$upower_string"
    get_lower_state "$upower_string"
    get_screen_state
}

update_state
#show init state
echo "state machine init ok"
echo $lid_close
echo $on_battery
echo $lower_than_10
echo $screen_open

mkfifo /tmp/upower_fifo
chmod 666 /tmp/upower_fifo

#enter state machine
echo "enter state machine"
while true;do
    read fifo_data < /tmp/upower_fifo
    echo $fifo_data
    update_state
    result=$(/usr/bin/ec_led_control $lid_close $on_battery $lower_than_10 $screen_open)
    echo $result
done

